<!DOCTYPE html>
<html lang="en">

<head>
    <title>Order Manager</title>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <!-- Bootstrap -->
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.2.1/css/all.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

    <!-- Data Table-->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.13.1/css/jquery.dataTables.css">
    <script src="https://cdn.datatables.net/1.13.1/js/jquery.dataTables.js"></script>
</head>

<body>
    <div class="container p-2">
        <div class="row form-group">
            <div class="col-sm-12 text-center">
                <h3><b>DANH SÁCH ĐƠN HÀNG</b></h3>
            </div>
        </div>
        <div class="row form-group bg-light p-3 rounded">
            <div class="col-sm-2">
                <label class="col-form-label"><b>Trạng thái Order</b></label>
            </div>
            <div class="col-sm-3">
                <select id="select-status" class="form-control">
                    <option value="">Chọn trạng thái order</option>
                    <option value="Open">Open</option>
                    <option value="Confirmed">Confirmed</option>
                    <option value="Cancel">Cancel</option>
                </select>
            </div>
            <div class="col-sm-2">
                <label class="col-form-label"><b>Loại Pizza</b></label>
            </div>
            <div class="col-sm-3">
                <select id="select-pizza" class="form-control">
                    <option value="">Chọn loại pizza</option>
                    <option value="Hawaii">Hawaii</option>
                    <option value="Bacon">Bacon</option>
                    <option value="Seafood">Seafood</option>
                </select>
            </div>
            <div class="col-sm-2">
                <button id="btn-filter" class="btn btn-success w-100">Filter Data &nbsp; <i class="fa-solid fa-filter"></i></button>
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-12">
                <table id="order-table" class="table table-bordered table-striped table-hover">
                    <thead>
                        <tr>
                            <th>Mã đơn</th>
                            <th>Combo</th>
                            <th>Pizza</th>
                            <th>Drink</th>
                            <th>Thành tiền</th>
                            <th>Họ và tên</th>
                            <th>Điện thoại</th>
                            <th>Trạng thái</th>
                            <th>Action</th>
                        </tr>
                    </thead>
                    <tbody></tbody>
                </table>
            </div>
        </div>
    </div>
</body>

<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";

    var gOrderList = [];
    var gOrderId = "";
    
    const gTABLE_ROW = ["orderCode", "kichCo", "loaiPizza", "idLoaiNuocUong", "thanhTien", "hoTen", "soDienThoai", "trangThai", "action"];
    const gCODE_COL = 0;
    const gCOMBO_COL = 1;
    const gPIZZA_COL = 2;
    const gDRINK_COL = 3;
    const gTOTAL_COL = 4;
    const gNAME_COL = 5;
    const gPHONE_COL = 6;
    const gSTATUS_COL = 7;
    const gACTION_COL = 8;
    var gTableOrder = $("#order-table").DataTable({
        columns: [
            {data: gTABLE_ROW[gCODE_COL]},
            {data: gTABLE_ROW[gCOMBO_COL]},
            {data: gTABLE_ROW[gPIZZA_COL]},
            {data: gTABLE_ROW[gDRINK_COL]},
            {data: gTABLE_ROW[gTOTAL_COL]},
            {data: gTABLE_ROW[gNAME_COL]},
            {data: gTABLE_ROW[gPHONE_COL]},
            {data: gTABLE_ROW[gSTATUS_COL]},
            {data: gTABLE_ROW[gACTION_COL]},
        ],
        columnDefs: [
            {
                targets: gACTION_COL,
                defaultContent: '<button id="btn-detail" class="btn btn-success w-100">Detail</button>'
            }
        ]
    })

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    // gán sự kiện tải trang/F5
    $(document).ready(onPageLoading);

    // gán sự kiện click button Filter
    $(document).on("click", "#btn-filter", onBtnFilterClick);

    // gán sự kiện click button Detail
    $(document).on("click", "#btn-detail", onBtnDetailClick);
    
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // function xử lý sự kiện load trang/F5
    function onPageLoading() {
        // Gọi API lấy danh sách đơn hàng và lưu vào biến toàn cục gOrderList
        callApiOrderList();
        // Xử lý hiển thị
        insertOrderListToTable(gOrderList);
    }

    // function xử lý sự kiện click button Filter
    function onBtnFilterClick() {
        // Khai báo đối tượng chứa dữ liệu filter
        let vFilterData = {
            trangThai: "",
            loaiPizza: "",
        };
        // Thu thập dữ liệu
        getFilterData(vFilterData);
        console.log(vFilterData);
        // Kiểm tra dữ liệu
        // Xử lý hiển thị
        let vResultData = getFilteredDataObject(vFilterData);
        insertOrderListToTable(vResultData);
    }

    // function xử lý sự kiện click button Detail (Chi tiết)
    function onBtnDetailClick() {
        console.log("%cBUTTON DETAIL - CLICK", "color: green");
        getUserDetailOnClick(this);
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // function gọi API lấy danh sách đơn hàng và lưu vào biến toàn cục gOrderList 
    function callApiOrderList(paramXmlHttp) {
        return $.ajax({
            url: gBASE_URL,
            type: "GET",
            async: false,
        }).done(function(orderList) {
            gOrderList = orderList;
        }).fail(function(error) {
            console.log("Lấy dữ liệu Order List không thành công");
        });
    }

    // function insert danh sách đơn hàng vào table
    function insertOrderListToTable(paramOrderList) {
        gTableOrder.clear();
        gTableOrder.rows.add(paramOrderList);
        gTableOrder.draw();
    }

    // function thu thập dữ liệu filter
    // function return tham số đối tượng paramFilterData chứa dữ liệu người dùng chọn trên form
    function getFilterData(paramFilterData) {
        paramFilterData.trangThai = $("#select-status").val();
        paramFilterData.loaiPizza = $("#select-pizza").val();
    }

    // function xử lý filter data theo firstname và lastname
    function getFilteredDataObject(paramFilterData) {
        let vFilteredData = gOrderList.filter(function(order) {
            return (order.trangThai.toLowerCase() == paramFilterData.trangThai.toLowerCase() || paramFilterData.trangThai == "") 
                && (order.loaiPizza.toLowerCase() == paramFilterData.loaiPizza.toLowerCase() || paramFilterData.loaiPizza == "");
        })
        return vFilteredData;
    }

    // function thu thập dữ liệu của Row khi click button Detail
    function getUserDetailOnClick(paramButton) {
        let vRowClicked = $(paramButton).closest("tr");
        let vUserData = gTableOrder.row(vRowClicked).data();
        console.log(vUserData);
    }

</script>

</html>